----------------------------------------------------------------------------------
-- Company: www.uqu.edu.sa & ghadeer.net
-- Engineer: Ghassan Bati
-- 
-- Create Date:    21:56:02 11/28/2007 
-- Design Name: 
-- Module Name:    mux - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity mux is
    Port ( A0 : in  STD_LOGIC;
           A1 : in  STD_LOGIC;
           A2 : in  STD_LOGIC;
           A3 : in  STD_LOGIC;
           S : in  STD_LOGIC_VECTOR (1 downto 0);
           B : out  STD_LOGIC);
end mux;

architecture Behavioral of mux is

begin
		process(A3,A2,A1,A0,S)
		begin
--This part to select the output depend on the input--
			case S is
				when "00" =>B <= A0;
				when "01" =>B <= A1;
				when "10" =>B <= A2;
				when "11" =>B <= A3;
				when others => null ;
			end case;
		end process;
end Behavioral;